/*  arith.h                                  */
/*                                           */
/*  Michael Schindler                        */
/*  Jan. 1997                                */
/*  http://eiunix.tuwien.ac.at/~michael      */

#ifndef arith_h
#define aith_h

#include "b_i_t.h"

/* Start encoding */
void start_encoding( char c );

/* Encode a symbol with probabilities stored in b_i_t */
#define encode_symbol(_s,_tbl) \
                 encode_freq((_tbl)->f[_s], getcf(_s,_tbl), (_tbl)->totfreq);

/* Encode a symbol using the symbol frequency, the frequency of < symbols  */
/* and the total frequency. Both encodes may be used intermixed            */
inline void encode_freq( freq sy_f, freq lt_f, freq tot_f );

/* Finish encoding */
void done_encoding( void );

/* Start decoding */
int start_decoding( void );

/* Decode a symbol with probabilities stored in b_i_t and update variables */
inline symb decode_symbol( cumtbl *tbl );

/* Calculate culmulative frequency for next symbol. does NO update! */
inline freq decode_culfreq( freq tot_f );

/* Update decoding variables using the symbol frequency, the frequency of  */
/* < symbols and the total frequency. Both decodes may be used intermixed  */
inline void decode_update(freq sy_f, freq lt_f, freq tot_f);

/* Finish decoding */
void done_decoding( void );

#endif
