
#include <stdio.h>
#if !defined( unix )
#include <io.h>
#endif
#include <fcntl.h>

#include "model.h"

int main( int argc, char *argv[] )
{   int ch;
#ifdef TICK
    int ticker = 0;
#endif

    fprintf( stderr, "Arithmetic decoding on " );
    if ( argc > 1 ) {
        freopen( argv[ 1 ], "rb", stdin );
        fprintf( stderr, "%s", argv[ 1 ] );
    } else
        fprintf( stderr, "stdin" );
    fprintf( stderr, " to " );
    if ( argc > 2 ) {
        freopen( argv[ 2 ], "wb", stdout );
        fprintf( stderr, "%s", argv[ 2 ] );
    } else
        fprintf( stderr, "stdout" );
    fprintf( stderr, "\n" );
#if !defined( unix )
    setmode( fileno( stdin ), O_BINARY );
    setmode( fileno( stdout ), O_BINARY );
#endif
    initmodel(0);
    for (;;) {                                  /* Loop through characters. */
#ifdef TICK
        if ( ( ticker++ % 1024 ) == 0 )
            putc( '.', stderr );
#endif
        if ((ch=decode())==EOF)
            break;
        putchar(ch);
    }
    deletemodel();
#ifdef TICK
    putc( '\n', stderr );
#endif
    return 0;
}
